searchNodes=[{"type":"module","title":"gen_icmp","doc":"gen_icmp is an interface for using ICMP and ICMPv6 sockets gen_icmp uses raw sockets and abuses gen_udp for the socket handling. gen_icmp should work on Linux and BSDs. Examples 1 &gt; gen_icmp : ping ( &quot;hex.pm&quot; ) . [ { ok , &quot;hex.pm&quot; , { 35 , 241 , 14 , 39 } , { 35 , 241 , 14 , 39 } , { 61261 , 0 , 116 , 215 } , &lt;&lt; &quot; !\\&quot;#$%&amp;&#39;()*+,-./0123456789:;&lt;=&gt;?@ABCDEFGHIJKLMNO&quot; &gt;&gt; } ]","ref":"gen_icmp.html"},{"type":"function","title":"gen_icmp.addr_list/3","doc":"Resolve a host list. Examples 1 &gt; gen_icmp : addr_list ( inet , [ &quot;8.8.8.8&quot; , &quot;google.com&quot; , &quot;cloudflare.com&quot; , { 8 , 8 , 8 , 8 } , &quot;8.8.8.8&quot; ] , false ) . [ { ok , &quot;8.8.8.8&quot; , { 8 , 8 , 8 , 8 } } , { ok , &quot;google.com&quot; , { 172 , 217 , 165 , 14 } } , { ok , &quot;cloudflare.com&quot; , { 104 , 16 , 133 , 229 } } , { ok , { 8 , 8 , 8 , 8 } , { 8 , 8 , 8 , 8 } } , { ok , &quot;8.8.8.8&quot; , { 8 , 8 , 8 , 8 } } ] 2 &gt; [ { ok , &quot;8.8.8.8&quot; , { 8 , 8 , 8 , 8 } } , { ok , &quot;google.com&quot; , { 172 , 217 , 165 , 14 } } , { ok , &quot;cloudflare.com&quot; , { 104 , 16 , 132 , 229 } } , { ok , &quot;cloudflare.com&quot; , { 104 , 16 , 133 , 229 } } , { ok , { 8 , 8 , 8 , 8 } , { 8 , 8 , 8 , 8 } } , { ok , &quot;8.8.8.8&quot; , { 8 , 8 , 8 , 8 } } ]","ref":"gen_icmp.html#addr_list/3"},{"type":"function","title":"gen_icmp.close/1","doc":"Close the ICMP socket. Examples 1 &gt; { ok , S } = gen_icmp : open ( ) . { ok , &lt; 0.224 . 0 &gt; } 2 &gt; gen_icmp : close ( S ) . ok","ref":"gen_icmp.html#close/1"},{"type":"function","title":"gen_icmp.controlling_process/2","doc":"Change the controlling process of the ICMP socket. Change the process owning the socket. Allows another process to receive the ICMP responses.","ref":"gen_icmp.html#controlling_process/2"},{"type":"function","title":"gen_icmp.echo/3","doc":"Generate ICMP ECHO_REQUEST payload. Creates an ICMP echo packet with an 8 byte timestamp and a payload consisting of ASCII 32 to 79. Examples 1 &gt; gen_icmp : echo ( inet , 0 , 0 ) . &lt;&lt; 8 , 0 , 166 , 49 , 0 , 0 , 0 , 0 , 255 , 253 , 243 , 182 , 71 , 2 , 233 , 209 , 32 , 33 , 34 , 35 , 36 , 37 , 38 , 39 , 40 , 41 , 42 , 43 , 44 , . . . &gt;&gt;","ref":"gen_icmp.html#echo/3"},{"type":"function","title":"gen_icmp.echo/4","doc":"Generate ICMP ECHO_REQUEST with user specified payload. Creates an ICMP echo packet with the results of erlang:monotonic_time(micro_seconds) used as the timestamp and a user specified payload (padded to 64 bytes). Examples 1 &gt; gen_icmp : echo ( inet , 0 , 0 , &lt;&lt; &quot;ping&quot; , 0 : ( 60 * 8 ) &gt;&gt; ) . &lt;&lt; 8 , 0 , 25 , 47 , 0 , 0 , 0 , 0 , 112 , 105 , 110 , 103 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , . . . &gt;&gt;","ref":"gen_icmp.html#echo/4"},{"type":"function","title":"gen_icmp.family/1","doc":"Get socket family. Returns the socket family: inet (IPv4), inet6 (IPv6) Examples 1 &gt; { ok , S } = gen_icmp : open ( [ inet6 ] ) . { ok , &lt; 0.224 . 0 &gt; } 2 &gt; gen_icmp : family ( S ) . inet6","ref":"gen_icmp.html#family/1"},{"type":"function","title":"gen_icmp.filter/1","doc":"Get ICMPv6 socket filter. Retrieves the ICMPv6 filter for a socket. For ICMPv4 sockets, the atom unsupported is returned. Examples 1 &gt; { ok , S } = gen_icmp : open ( [ inet6 ] ) . { ok , &lt; 0.299 . 0 &gt; } 2 &gt; gen_icmp : filter ( S ) . { ok , &lt;&lt; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , . . . &gt;&gt; }","ref":"gen_icmp.html#filter/1"},{"type":"function","title":"gen_icmp.filter/2","doc":"Set ICMPv6 socket filter. Sets an ICMPv6 filter on a socket. For ICMPv4 sockets, the atom unsupported is returned. Filters can be generated by using the icmp6_filter functions. Examples 1 &gt; { ok , S } = gen_icmp : open ( [ inet6 ] ) . { ok , &lt; 0.299 . 0 &gt; } 2 &gt; gen_icmp : filter ( S , gen_icmp : icmp6_filter_setpassall ( ) ) . ok","ref":"gen_icmp.html#filter/2"},{"type":"function","title":"gen_icmp.get_ttl/2","doc":"Get the TTL for a file descriptor. Examples 1 &gt; gen_icmp : get_ttl ( gen_icmp : getfd ( S ) , gen_icmp : family ( S ) ) . { ok , 64 }","ref":"gen_icmp.html#get_ttl/2"},{"type":"function","title":"gen_icmp.getfd/1","doc":"Get underlying file descriptor for socket. Examples 1 &gt; { ok , S } = gen_icmp : open ( ) . { ok , &lt; 0.221 . 0 &gt; } 2 &gt; gen_icmp : getfd ( S ) . 20","ref":"gen_icmp.html#getfd/1"},{"type":"function","title":"gen_icmp.icmp6_filter_setblock/2","doc":"Update a filter to block an ICMPv6 type. Examples To generate a filter that allowed only ICMP6_PACKET_TOO_BIG messages: 1 &gt; { ok , Socket } = gen_icmp : open ( [ inet6 ] ) . { ok , &lt; 0.300 . 0 &gt; } 2 &gt; Filter = gen_icmp : icmp6_filter_setblock ( packet_too_big , gen_icmp : icmp6_filter_setpassall ( ) ) . &lt;&lt; 4 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , . . . &gt;&gt; 3 &gt; gen_icmp : filter ( Socket , Filter ) . ok See also: filter/2 .","ref":"gen_icmp.html#icmp6_filter_setblock/2"},{"type":"function","title":"gen_icmp.icmp6_filter_setblockall/0","doc":"ICMPv6 filtering: block all ICMP types. See also: icmp6_filter_setpass/2 .","ref":"gen_icmp.html#icmp6_filter_setblockall/0"},{"type":"function","title":"gen_icmp.icmp6_filter_setpass/2","doc":"Update a filter to allow an ICMPv6 type. Examples To generate a filter that allowed only ICMP6_ECHO_REPLY messages: { ok , Socket } = gen_icmp : open ( [ inet6 ] ) , Filter = gen_icmp : icmp6_filter_setpass ( echo_reply , gen_icmp : icmp6_filter_setblockall ( ) ) , ok = gen_icmp : filter ( Socket , Filter ) . See also: filter/2 .","ref":"gen_icmp.html#icmp6_filter_setpass/2"},{"type":"function","title":"gen_icmp.icmp6_filter_setpassall/0","doc":"IPv6 ICMP filtering: allow all ICMP types. See also: icmp6_filter_setblock/2 .","ref":"gen_icmp.html#icmp6_filter_setpassall/0"},{"type":"function","title":"gen_icmp.icmp6_filter_willblock/2","doc":"Test if a filter blocks an ICMPv6 type. Examples 1 &gt; Filter = gen_icmp : icmp6_filter_setblock ( packet_too_big , gen_icmp : icmp6_filter_setpassall ( ) ) . &lt;&lt; 4 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , . . . &gt;&gt; 2 &gt; gen_icmp : icmp6_filter_willblock ( echo_reply , Filter ) . false 3 &gt; gen_icmp : icmp6_filter_willblock ( packet_too_big , Filter ) . true","ref":"gen_icmp.html#icmp6_filter_willblock/2"},{"type":"function","title":"gen_icmp.icmp6_filter_willpass/2","doc":"Test if a filter allows an ICMPv6 type. Examples 1 &gt; Filter = gen_icmp : icmp6_filter_setblock ( packet_too_big , gen_icmp : icmp6_filter_setpassall ( ) ) . &lt;&lt; 4 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , . . . &gt;&gt; 2 &gt; gen_icmp : icmp6_filter_willpass ( echo_reply , Filter ) . true 3 &gt; gen_icmp : icmp6_filter_willpass ( packet_too_big , Filter ) . false","ref":"gen_icmp.html#icmp6_filter_willpass/2"},{"type":"function","title":"gen_icmp.open/0","doc":"Open an ICMP socket. By default, the ICMP socket is opened in {active,false} mode. No packets will be received by the socket. setopts/2 can be used to place the socket in {active,true} mode. gen_icmp first attempts to natively open the socket and falls back to forking the setuid helper program if beam does not have the appropriate privileges. Privileges to open a raw socket can be given by, for example, running as root or, on Linux, granting the CAP_NET_RAW capability to beam: setcap cap_net_raw=ep /usr/local/lib/erlang/erts-5.8.3/bin/beam.smp Only the owning process will receive ICMP packets (see controlling_process/2 to change the owner). The process owning the raw socket will receive all ICMP packets sent to the host. Messages sent to the controlling process are: {icmp, Socket, Address, TTL, Packet} Where: * Socket is the pid of the gen_icmp process * Address is a tuple representing the IPv4 or IPv6 source address * TTL: IPv4: TTL taken from the IP header * TTL: IPv6: the socket's hop limit returned from getsockopt(IPV6_UNICAST_HOPS) (this is not the packet's TTL, it is the socket's max TTL) * Packet is the complete ICMP packet including the ICMP headers Examples 1 &gt; gen_icmp : open ( ) . { ok , &lt; 0.299 . 0 &gt; }","ref":"gen_icmp.html#open/0"},{"type":"function","title":"gen_icmp.open/1","doc":"Open an ICMP socket with raw socket options. See the https://github.com/msantos/procket for the raw socket options and for instructions on setting up the setuid helper. Examples 1 &gt; gen_icmp : open ( [ { ttl , 1 } , inet6 ] ) . { ok , &lt; 0.302 . 0 &gt; }","ref":"gen_icmp.html#open/1"},{"type":"function","title":"gen_icmp.open/2","doc":"Open an ICMP socket with options. Examples 1 &gt; gen_icmp : open ( [ { ttl , 1 } , inet6 ] , [ list ] ) . { ok , &lt; 0.302 . 0 &gt; }","ref":"gen_icmp.html#open/2"},{"type":"function","title":"gen_icmp.packet/2","doc":"Create an ICMP packet. Convenience function for creating arbitrary ICMP packets. This function will calculate the ICMP checksum and insert it into the packet. Examples 1 &gt; rr ( &quot;_build/default/lib/pkt/include/pkt_icmp.hrl&quot; ) . [ icmp ] 2 &gt; gen_icmp : packet ( # icmp { } , &lt;&lt; &quot;abc&quot; &gt;&gt; ) . &lt;&lt; 8 , 0 , 51 , 157 , 0 , 0 , 0 , 0 , 97 , 98 , 99 &gt;&gt;","ref":"gen_icmp.html#packet/2"},{"type":"function","title":"gen_icmp.packet/3","doc":"Construct an ICMP or ICMPv6 packet payload. Examples 1 &gt; gen_icmp : packet ( inet , [ { type , dest_unreach } , { code , unreach_port } ] , &lt;&lt; &quot;payload goes here&quot; &gt;&gt; ) . &lt;&lt; 3 , 3 , 135 , 239 , 0 , 0 , 0 , 0 , 112 , 97 , 121 , 108 , 111 , 97 , 100 , 32 , 103 , 111 , 101 , 115 , 32 , 104 , 101 , 114 , 101 &gt;&gt;","ref":"gen_icmp.html#packet/3"},{"type":"function","title":"gen_icmp.parse/1","doc":"Parse or resolve an IPv4 host identifier. Examples 1 &gt; gen_icmp : parse ( &quot;8.8.8.8&quot; ) . { ok , [ { 8 , 8 , 8 , 8 } ] } 2 &gt; gen_icmp : parse ( { 8 , 8 , 8 , 8 } ) . { ok , [ { 8 , 8 , 8 , 8 } ] } 3 &gt; gen_icmp : parse ( &quot;2001:4860:4860::8888&quot; ) . { ok , [ { 8193 , 18528 , 18528 , 0 , 0 , 0 , 0 , 34952 } ] } 4 &gt; gen_icmp : parse ( &quot;cloudflare.com&quot; ) . { ok , [ { 104 , 16 , 132 , 229 } , { 104 , 16 , 133 , 229 } ] } 5 &gt; gen_icmp : parse ( &quot;foo&quot; ) . { error , nxdomain }","ref":"gen_icmp.html#parse/1"},{"type":"function","title":"gen_icmp.parse/2","doc":"Parse or resolve a host identifier. Examples 1 &gt; gen_icmp : parse ( inet , &quot;cloudflare.com&quot; ) . { ok , [ { 104 , 16 , 133 , 229 } , { 104 , 16 , 132 , 229 } ] } 2 &gt; gen_icmp : parse ( inet6 , &quot;cloudflare.com&quot; ) . { ok , [ { 9734 , 18176 , 0 , 0 , 0 , 0 , 26640 , 34021 } , { 9734 , 18176 , 0 , 0 , 0 , 0 , 26640 , 34277 } ] }","ref":"gen_icmp.html#parse/2"},{"type":"function","title":"gen_icmp.ping/1","doc":"Send an ICMP ECHO_REQUEST. ping/1 is a convenience function to send a single ping packet. The argument to ping/1 can be either a hostname or a list of hostnames. Examples 1 &gt; gen_icmp : ping ( &quot;google.com&quot; ) . [ { ok , &quot;google.com&quot; , { 142 , 251 , 41 , 46 } , { 142 , 251 , 41 , 46 } , { 61261 , 0 , 116 , 84 } , &lt;&lt; &quot; !\\&quot;#$%&amp;&#39;()*+,-./0123456789:;&lt;=&gt;?@ABCDEFGHIJKLMNO&quot; &gt;&gt; } ] See also: ping/3 .","ref":"gen_icmp.html#ping/1"},{"type":"function","title":"gen_icmp.ping/2","doc":"Send an ICMP ECHO_REQUEST with options. Ping a host or a list of hosts. Examples 1 &gt; gen_icmp : ping ( &quot;google.com&quot; , [ inet6 ] ) . [ { ok , &quot;google.com&quot; , { 9735 , 63664 , 16395 , 2052 , 0 , 0 , 0 , 8206 } , { 9735 , 63664 , 16395 , 2052 , 0 , 0 , 0 , 8206 } , { 61261 , 0 , 64 , 53 } , &lt;&lt; &quot; !\\&quot;#$%&amp;&#39;()*+,-./0123456789:;&lt;=&gt;?@ABCDEFGHIJKLMNO&quot; &gt;&gt; } ] See also: ping/3 .","ref":"gen_icmp.html#ping/2"},{"type":"function","title":"gen_icmp.ping/3","doc":"Send an ICMP ECHO_REQUEST. To prevent the process mailbox from being flooded with ICMP messages, ping/3 will put the socket into {active,false} mode after completing. The ping/3 function blocks until either an ICMP ECHO REPLY is received from all hosts or Timeout is reached. Id and sequence are used to differentiate ping responses. Usually, the sequence is incremented for each ping in one run. A list of responses is returned. If the ping was successful, the elapsed time in milliseconds is included (calculated by subtracting the current time from the time we sent in the ICMP ECHO packet and returned to us in the ICMP ECHOREPLY payload) where: * Host: the provided hostname * Address: the resolved IPv4 or IPv6 network address represented as a 4 or 8-tuple used in the ICMP echo request * ReplyAddr: the IPv4 or IPv6 network address originating the ICMP echo reply The timeout is set for all ICMP packets and is set after all packets have been sent out. By default only one address per hostname is pinged. To enable pinging all addresses per hostname pass {multi, true} to options. A ping payload contains an 8 byte timestamp in microseconds. When creating a custom payload, the first 8 bytes of the ICMP echo reply payload will be used for calculating the elapsed time. To disable this behaviour, use the option {timestamp,false} (the elapsed time in the return value will be set to 0). The timeout defaults to 5 seconds. ICMPv6 sockets can restrict which ICMPv6 types are received by the socket using the filter option. The filter argument is a binary generated using the icmp6_filter functions described below. The default filter allows: ICMP6_ECHO_REPLY, ICMP6_DST_UNREACH, ICMP6_PACKET_TOO_BIG, ICMP6_TIME_EXCEEDED and ICMP6_PARAM_PROB. Note: ping/3 does not restore the original filter on the socket. Examples 1 &gt; { ok , S } = gen_icmp : open ( [ inet6 ] ) . { ok , &lt; 0.299 . 0 &gt; } 2 &gt; gen_icmp : ping ( S , [ &quot;google.com&quot; ] , [ ] ) . [ { ok , &quot;google.com&quot; , { 9735 , 63664 , 16395 , 2051 , 0 , 0 , 0 , 8206 } , { 9735 , 63664 , 16395 , 2051 , 0 , 0 , 0 , 8206 } , { 61261 , 0 , 64 , 110 } , &lt;&lt; &quot; !\\&quot;#$%&amp;&#39;()*+,-./0123456789:;&lt;=&gt;?@ABCDEFGHIJKLMNO&quot; &gt;&gt; } ] 3 &gt; gen_icmp : ping ( S , [ &quot;2001:4860:4860::8888&quot; ] , [ ] ) . [ { ok , &quot;2001:4860:4860::8888&quot; , { 8193 , 18528 , 18528 , 0 , 0 , 0 , 0 , 34952 } , { 8193 , 18528 , 18528 , 0 , 0 , 0 , 0 , 34952 } , { 61261 , 0 , 64 , 20 } , &lt;&lt; &quot; !\\&quot;#$%&amp;&#39;()*+,-./0123456789:;&lt;=&gt;?@ABCDEFGHIJKLMNO&quot; &gt;&gt; } ] 4 &gt; gen_icmp : ping ( S , [ &quot;2001:4860:4860::8888&quot; , &quot;google.com&quot; ] , [ ] ) . [ { ok , &quot;google.com&quot; , { 9735 , 63664 , 16395 , 2051 , 0 , 0 , 0 , 8206 } , { 9735 , 63664 , 16395 , 2051 , 0 , 0 , 0 , 8206 } , { 61261 , 1 , 64 , 23 } , &lt;&lt; &quot; !\\&quot;#$%&amp;&#39;()*+,-./0123456789:;&lt;=&gt;?@ABCDEFGHIJKLMNO&quot; &gt;&gt; } , { ok , &quot;2001:4860:4860::8888&quot; , { 8193 , 18528 , 18528 , 0 , 0 , 0 , 0 , 34952 } , { 8193 , 18528 , 18528 , 0 , 0 , 0 , 0 , 34952 } , { 61261 , 0 , 64 , 23 } , &lt;&lt; &quot; !\\&quot;#$%&amp;&#39;()*+,-./0123456789:;&lt;=&gt;?@ABCDEFGHIJKLMNO&quot; &gt;&gt; } ] 5 &gt; gen_icmp : close ( S ) . ok","ref":"gen_icmp.html#ping/3"},{"type":"function","title":"gen_icmp.recv/2","doc":"Read data from an ICMP socket. This function receives a packet from a socket in passive mode. Examples 1 &gt; { ok , S } = gen_icmp : open ( ) . { ok , &lt; 0.224 . 0 &gt; } 2 &gt; gen_icmp : send ( S , &quot;google.com&quot; , gen_icmp : echo ( inet , 0 , 0 ) ) . ok 3 &gt; gen_icmp : recv ( S , 1 ) . { ok , { { 142 , 251 , 32 , 78 } , &lt;&lt; 69 , 0 , 0 , 84 , 0 , 0 , 0 , 0 , 116 , 1 , 214 , 38 , 142 , 251 , 32 , 78 , 100 , 115 , 92 , 198 , 0 , 0 , 19 , 125 , 0 , . . . &gt;&gt; } } 4 &gt; gen_icmp : close ( S ) . ok","ref":"gen_icmp.html#recv/2"},{"type":"function","title":"gen_icmp.recv/3","doc":"Read data from an ICMP socket with timeout. The optional Timeout parameter specifies a timeout in milliseconds. The default value is infinity. Examples 1 &gt; { ok , S } = gen_icmp : open ( ) . { ok , &lt; 0.299 . 0 &gt; } 2 &gt; gen_icmp : send ( S , &quot;google.com&quot; , gen_icmp : echo ( inet , 0 , 0 ) ) . ok 3 &gt; gen_icmp : recv ( S , 1 , 5000 ) . { ok , { { 142 , 251 , 41 , 78 } , &lt;&lt; 69 , 0 , 0 , 84 , 0 , 0 , 0 , 0 , 116 , 1 , 205 , 38 , 142 , 251 , 41 , 78 , 100 , 115 , 92 , 198 , 0 , 0 , 100 , 77 , 0 , . . . &gt;&gt; } } 4 &gt; gen_icmp : recv ( S , 1 , 5000 ) . { error , timeout } 5 &gt; gen_icmp : close ( S ) . ok","ref":"gen_icmp.html#recv/3"},{"type":"function","title":"gen_icmp.send/3","doc":"Send data via an ICMP socket. Like the gen_udp and gen_tcp modules, any process can send ICMP packets but only the owner will receive the responses. Examples 1 &gt; { ok , S } = gen_icmp : open ( ) . { ok , &lt; 0.224 . 0 &gt; } 2 &gt; gen_icmp : send ( S , &quot;google.com&quot; , gen_icmp : echo ( inet , 0 , 0 ) ) . ok 3 &gt; gen_icmp : recv ( S , 1 ) . { ok , { { 142 , 251 , 32 , 78 } , &lt;&lt; 69 , 0 , 0 , 84 , 0 , 0 , 0 , 0 , 116 , 1 , 214 , 38 , 142 , 251 , 32 , 78 , 100 , 115 , 92 , 198 , 0 , 0 , 19 , 125 , 0 , . . . &gt;&gt; } } 4 &gt; gen_icmp : close ( S ) . ok","ref":"gen_icmp.html#send/3"},{"type":"function","title":"gen_icmp.set_ttl/3","doc":"Set the TTL on a file descriptor. Examples 1 &gt; gen_icmp : set_ttl ( gen_icmp : getfd ( S ) , gen_icmp : family ( S ) , 1 ) . ok 2 &gt; gen_icmp : get_ttl ( gen_icmp : getfd ( S ) , gen_icmp : family ( S ) ) . { ok , 1 }","ref":"gen_icmp.html#set_ttl/3"},{"type":"function","title":"gen_icmp.setopts/2","doc":"Set socket options. For options, see the inet man page. Simply calls inet:setopts/2 on the gen_udp socket. setopts/2 can be used to toggle the socket between passive and active mode. Examples { ok , Socket } = gen_icmp : open ( ) , % socket is {active,false} ok = gen_icmp : setopts ( Socket , [ { active , true } ] ) , % do stuff with the socket ok = gen_icmp : setopts ( Socket , [ { active , false } ] ) .","ref":"gen_icmp.html#setopts/2"},{"type":"type","title":"gen_icmp.elapsed/0","doc":"","ref":"gen_icmp.html#t:elapsed/0"},{"type":"type","title":"gen_icmp.fd/0","doc":"","ref":"gen_icmp.html#t:fd/0"},{"type":"type","title":"gen_icmp.icmp6_filter/0","doc":"","ref":"gen_icmp.html#t:icmp6_filter/0"},{"type":"type","title":"gen_icmp.id/0","doc":"","ref":"gen_icmp.html#t:id/0"},{"type":"type","title":"gen_icmp.int32_t/0","doc":"","ref":"gen_icmp.html#t:int32_t/0"},{"type":"type","title":"gen_icmp.packet_option/0","doc":"","ref":"gen_icmp.html#t:packet_option/0"},{"type":"type","title":"gen_icmp.sequence/0","doc":"","ref":"gen_icmp.html#t:sequence/0"},{"type":"type","title":"gen_icmp.socket/0","doc":"","ref":"gen_icmp.html#t:socket/0"},{"type":"type","title":"gen_icmp.ttlx/0","doc":"ICMP packet time to live (renamed to avoid conflict with ttl() defined in the pkt header file)","ref":"gen_icmp.html#t:ttlx/0"},{"type":"type","title":"gen_icmp.uint8_t/0","doc":"","ref":"gen_icmp.html#t:uint8_t/0"},{"type":"type","title":"gen_icmp.uint16_t/0","doc":"","ref":"gen_icmp.html#t:uint16_t/0"},{"type":"type","title":"gen_icmp.uint32_t/0","doc":"","ref":"gen_icmp.html#t:uint32_t/0"},{"type":"module","title":"tracert","doc":"Perform a traceroute. Send a probe packet with the time to live set from 1. Monitor an ICMP socket for ICMP responses or timeout. Examples 1 &gt; tracert : host ( &quot;hex.pm&quot; ) .","ref":"tracert.html"},{"type":"function","title":"tracert.close/1","doc":"Close the ICMP socket. Examples 1 &gt; { ok , Socket } = tracert : open ( ) . { ok , &lt; 0.164 . 0 &gt; } 2 &gt; tracert : close ( Socket ) . ok","ref":"tracert.html#close/1"},{"type":"function","title":"tracert.host/1","doc":"Perform an ICMP traceroute to a destination. Examples 1 &gt; tracert : host ( &quot;google.com&quot; ) . [ timeout , { { 142 , 250 , 57 , 128 } , 1174 , { icmp , &lt;&lt; 11 , 0 , 111 , 150 , 0 , 0 , 0 , 0 , 69 , 96 , 0 , 84 , 128 , 116 , 64 , 0 , 1 , 1 , 125 , 44 , 10 , 128 , . . . &gt;&gt; } } , { { 172 , 253 , 79 , 98 } , 3418 , { icmp , &lt;&lt; 11 , 0 , 244 , 238 , 0 , 17 , 0 , 0 , 69 , 96 , 0 , 84 , 128 , 117 , 64 , 0 , 1 , 1 , 125 , 43 , 10 , . . . &gt;&gt; } } , { { 192 , 178 , 45 , 217 } , 4103 , { icmp , &lt;&lt; 11 , 0 , 111 , 113 , 0 , 17 , 0 , 0 , 69 , 96 , 0 , 84 , 128 , 118 , 64 , 0 , 1 , 1 , 125 , 42 , . . . &gt;&gt; } } , { { 216 , 239 , 57 , 177 } , 2233 , { icmp , &lt;&lt; 11 , 0 , 111 , 113 , 0 , 17 , 0 , 0 , 69 , 96 , 0 , 84 , 128 , 119 , 64 , 0 , 1 , 1 , 125 , . . . &gt;&gt; } } , timeout , timeout , timeout , timeout , timeout , timeout , timeout , timeout , timeout , { { 173 , 194 , 195 , 100 } , 975 , { icmp , &lt;&lt; 0 , 0 , 184 , 52 , 205 , 52 , 0 , 0 , 32 , . . . &gt;&gt; } } ]","ref":"tracert.html#host/1"},{"type":"function","title":"tracert.host/2","doc":"Perform a traceroute to a destination with options. Examples 1 &gt; tracert : host ( &quot;google.com&quot; , [ { protocol , udp } ] ) . [ timeout , { { 142 , 250 , 57 , 212 } , 3671 , { icmp , &lt;&lt; 11 , 0 , 0 , 16 , 0 , 0 , 0 , 0 , 69 , 96 , 0 , 28 , 1 , 92 , 64 , 0 , 1 , 17 , 109 , 31 , 10 , 128 , . . . &gt;&gt; } } , { { 142 , 250 , 231 , 47 } , 2081 , { icmp , &lt;&lt; 11 , 0 , 255 , 254 , 0 , 17 , 0 , 0 , 69 , 96 , 0 , 28 , 1 , 93 , 64 , 0 , 1 , 17 , 109 , 30 , 10 , . . . &gt;&gt; } } , { { 142 , 251 , 236 , 131 } , 1322 , { icmp , &lt;&lt; 11 , 0 , 255 , 254 , 0 , 17 , 0 , 0 , 69 , 96 , 0 , 28 , 1 , 94 , 64 , 0 , 1 , 17 , 109 , 29 , . . . &gt;&gt; } } , { { 108 , 170 , 234 , 239 } , 3121 , { icmp , &lt;&lt; 11 , 0 , 255 , 254 , 0 , 17 , 0 , 0 , 69 , 96 , 0 , 28 , 1 , 95 , 64 , 0 , 1 , 17 , 109 , . . . &gt;&gt; } } , timeout , timeout , timeout , timeout , timeout , timeout , timeout , timeout , timeout , { { 64 , 233 , 191 , 139 } , 917 , { icmp , &lt;&lt; 3 , 3 , 8 , 13 , 0 , 0 , 0 , 0 , 69 , . . . &gt;&gt; } } ]","ref":"tracert.html#host/2"},{"type":"function","title":"tracert.host/3","doc":"Perform a traceroute to a destination. ICMP and UDP probes are supported. ICMP probes are the default. max_hops is the maximum TTL (default: 30) Set the time in milliseconds to wait for a response using the timeout option (default: 1000 ms). WARNING: if the response arrives after the timeout, tracert will insert spurious entries into the path. tracert will not spawn the setuid helper if the {setuid, false} option is used. In this case, beam must either be running as root or have the cap_net_raw privileges under Linux. The {sport, Port} option sets the initial source port for UDP probes. The port will be incremented by 1 for each subsequent probe (default: random high port). For ICMP probes, the ICMP ID field will be set to this value. The return value is an ordered list of tuples: * Address: the source address responding to the probe * MicroSeconds: time elapsed between the probe and receiving the response * Protocol: icmp or udp * Protocol data: a binary representing the received packet contents Examples 1 &gt; { ok , Socket } = tracert : open ( ) . { ok , &lt; 0.164 . 0 &gt; } 2 &gt; Path = tracert : host ( Socket , &quot;8.8.8.8&quot; , [ ] ) . [ timeout , timeout , timeout , timeout , timeout , timeout , timeout , timeout , timeout , timeout , { { 8 , 8 , 8 , 8 } , 750 , { icmp , &lt;&lt; 0 , 0 , 231 , 24 , 158 , 80 , 0 , 0 , 32 , 33 , 34 , 35 , 36 , . . . &gt;&gt; } } ] 3 &gt; tracert : close ( Socket ) . ok 4 &gt; tracert : path ( Path ) . [ timeout , timeout , timeout , timeout , timeout , timeout , timeout , timeout , timeout , timeout , { { 8 , 8 , 8 , 8 } , 750 , echoreply } ]","ref":"tracert.html#host/3"},{"type":"function","title":"tracert.open/0","doc":"Open an ICMP socket for traceroute Examples 1 &gt; { ok , Socket } = tracert : open ( ) . { ok , &lt; 0.164 . 0 &gt; }","ref":"tracert.html#open/0"},{"type":"function","title":"tracert.open/1","doc":"Open an ICMP socket for traceroute. Examples 1 &gt; { ok , Socket } = tracert : open ( [ inet6 , { protocol , udp } ] ) . { ok , &lt; 0.289 . 0 &gt; }","ref":"tracert.html#open/1"},{"type":"function","title":"tracert.path/1","doc":"Convert trace response to atoms. Convert the list of binaries returned by host/1,2,3 to atoms representing the ICMP response codes and UDP errors. Examples 1 &gt; { ok , Socket } = tracert : open ( ) . { ok , &lt; 0.164 . 0 &gt; } 2 &gt; Path = tracert : host ( Socket , &quot;8.8.8.8&quot; , [ ] ) . [ timeout , timeout , timeout , timeout , timeout , timeout , timeout , timeout , timeout , timeout , { { 8 , 8 , 8 , 8 } , 750 , { icmp , &lt;&lt; 0 , 0 , 231 , 24 , 158 , 80 , 0 , 0 , 32 , 33 , 34 , 35 , 36 , . . . &gt;&gt; } } ] 3 &gt; tracert : close ( Socket ) . ok 4 &gt; tracert : path ( Path ) . [ timeout , timeout , timeout , timeout , timeout , timeout , timeout , timeout , timeout , timeout , { { 8 , 8 , 8 , 8 } , 750 , echoreply } ]","ref":"tracert.html#path/1"},{"type":"function","title":"tracert.probe/5","doc":"Send a traceroute probe packet.","ref":"tracert.html#probe/5"},{"type":"type","title":"tracert.option/0","doc":"","ref":"tracert.html#t:option/0"},{"type":"type","title":"tracert.socket/0","doc":"","ref":"tracert.html#t:socket/0"},{"type":"extras","title":"Overview","doc":"gen_icmp aspires to be a simple interface for using ICMP and ICMPv6 sockets in Erlang, just like gen_tcp and gen_udp do for their protocol types; incidentally messing up Google searches for whomever someday writes a proper gen_icmp module. gen_icmp uses procket to get a raw socket and abuses gen_udp for the socket handling. gen_icmp should work on Linux and BSDs. For a simple example of sending a ping, also see: https://github.com/msantos/procket/blob/master/src/icmp.erl","ref":"readme.html"},{"type":"extras","title":"Overview - EXPORTS","doc":"open ( ) -&gt; { ok , Socket } open ( SocketOptions ) -&gt; { ok , Socket } open ( RawOptions , SocketOptions ) -&gt; { ok , Socket } Types Socket = pid ( ) RawOptions = [ RawOption ] RawOption = options ( ) SocketOptions = SocketOpt SocketOpt = [ { active , true } | { active , once } | { active , false } | inet | inet6 ] By default , the ICMP socket is opened in { active , false } mode . No packets will be received by the socket . setopts / 2 can be used to place the socket in { active , true } mode . See the procket README for the raw socket options and for instructions on setting up the setuid helper . gen_icmp first attempts to natively open the socket and falls back to forking the setuid helper program if beam does not have the appropriate privileges . Privileges to open a raw socket can be given by , for example , running as root or , on Linux , granting the CAP_NET_RAW capability to beam : setcap cap_net_raw = ep / usr / local / lib / erlang / erts - 5.8 . 3 / bin / beam . smp Only the owning process will receive ICMP packets ( see controlling_process / 2 to change the owner ) . The process owning the raw socket will receive all ICMP packets sent to the host . Messages sent to the controlling process are : { icmp , Socket , Address , TTL , Packet } Where : * Socket is the pid of the gen_icmp process * Address is a tuple representing the IPv4 or IPv6 source address * TTL is the IP TTL * IPv4 : TTL taken from the IP header * IPv6 : the socket &#39;s hop limit returned from getsockopt(IPV6_UNICAST_HOPS) (this is not the packet&#39; s TTL , it is the socket &#39;s max TTL) * Packet is the complete ICMP packet including the ICMP headers close(Socket) -&gt; ok | {error, Reason} Types Socket = pid() Reason = posix() Close the ICMP socket. send(Socket, Address, Packet) -&gt; ok | {error, Reason} Types Socket = pid() Address = tuple() Packet = binary() Reason = not_owner | posix() Like the gen_udp and gen_tcp modules, any process can send ICMP packets but only the owner will receive the responses. recv(Socket, Length) -&gt; {ok, {Address, Packet}} | {error, Reason} recv(Socket, Length, Timeout) -&gt; {ok, {Address, Packet}} | {error, Reason} Types Socket = socket() Length = int() Address = ip_address() Packet = [char()] | binary() Timeout = int() | infinity Reason = not_owner | posix() This function receives a packet from a socket in passive mode. The optional Timeout parameter specifies a timeout in milliseconds. The default value is infinity. controlling_process(Socket, Pid) -&gt; ok Types Socket = pid() Pid = pid() Change the process owning the socket. Allows another process to receive the ICMP responses. setopts(Socket, Options) -&gt; Types Socket = pid() Options = list() For options, see the inet man page. Simply calls inet:setopts/2 on the gen_udp socket. setopts/2 can be used to toggle the socket between passive and active mode: {ok, Socket} = gen_icmp:open(), % socket is {active,false} ok = gen_icmp:setopts(Socket, [{active, true}]), % do stuff with the socket ok = gen_icmp:setopts(Socket, [{active, false}]). ping(Host) -&gt; Responses ping(Host, Options) -&gt; Responses ping(Socket, Hosts, Options) -&gt; Responses Types Socket = pid() Host = Address | Hostname | Hosts Address = ReplyAddr = tuple() Hostname = string() Hosts = [ tuple() | string() ] Options = [ Option ] Option = {id, Id} | {sequence, Sequence} | {timeout, Timeout} | {data, Data} | {timestamp, boolean()} | {ttl, TTL} | {filter, Filter} | inet | inet6 Id = uint16() Sequence = uint16() Timeout = non_neg_integer() | infinity TTL = uint8() Data = binary() Filter = binary() Responses = [ Response ] Response = {ok, Host, Address, ReplyAddr, Details, Payload} | {error, ICMPError, Host, Address, ReplyAddr, Details, Payload} | {error, Error, Host, Address} Details = {Id, Sequence, TTL, Elapsed} Elapsed = int() | undefined Payload = binary() ICMPError = unreach_host | timxceed_intrans Error = timeout | inet:posix() ping/1 is a convenience function to send a single ping packet. The argument to ping/1 can be either a hostname or a list of hostnames. To prevent the process mailbox from being flooded with ICMP messages, ping/3 will put the socket into {active,false} mode after completing. The ping/3 function blocks until either an ICMP ECHO REPLY is received from all hosts or Timeout is reached. Id and sequence are used to differentiate ping responses. Usually, the sequence is incremented for each ping in one run. A list of responses is returned. If the ping was successful, the elapsed time in milliseconds is included (calculated by subtracting the current time from the time we sent in the ICMP ECHO packet and returned to us in the ICMP ECHOREPLY payload) where: Host: the provided hostname Address: the resolved IPv4 or IPv6 network address represented as a 4 or 8-tuple used in the ICMP echo request ReplyAddr: the IPv4 or IPv6 network address originating the ICMP echo reply The timeout is set for all ICMP packets and is set after all packets have been sent out. ping/1 and ping/2 open and close an ICMP socket for the user. For best performance, ping/3 should be used instead, with the socket being maintained between runs. By default only one address per hostname is pinged. To enable pinging all addresses per hostname pass {multi, true} to options. A ping payload contains an 8 byte timestamp in microseconds. When creating a custom payload, the first 8 bytes of the ICMP echo reply payload will be used for calculating the elapsed time. To disable this behaviour, use the option {timestamp,false} (the elapsed time in the return value will be set to 0). The timeout defaults to 5 seconds. ICMPv6 sockets can restrict which ICMPv6 types are received by the socket using the filter option. The filter argument is a binary generated using the icmp6_filter functions described below. The default filter allows: ICMP6_ECHO_REPLY, ICMP6_DST_UNREACH, ICMP6_PACKET_TOO_BIG, ICMP6_TIME_EXCEEDED and ICMP6_PARAM_PROB. Note: ping/3 does not restore the original filter on the socket. echo(Id, Sequence) -&gt; Packet Types Id = uint16() Sequence = uint16() Packet = binary() Creates an ICMP echo packet with an 8 byte timestamp and a payload consisting of ASCII 32 to 79. echo(Id, Sequence, Payload) -&gt; Packet Types Id = uint16() Sequence = uint16() Payload = binary() Packet = binary() Creates an ICMP echo packet with the results of erlang:now() used as the timestamp and a user specified payload (which should pad the packet to 64 bytes). packet(Header, Payload) -&gt; Packet Types Header = [ #icmp{} | Options ] Options = [ Opts ] Opts = [{type, Type} | {code, Code} | {id, Id} | {sequence, Sequence} | {gateway, Gateway} | {mtu, MTU} | {pointer, Pointer} | {ts_orig, TS_orig} | {ts_recv, TS_recv} | {ts_tx, TS_tx} ] Type = uint8() | ICMP_type Code = uint8() | ICMP_code ICMP_type = echoreply | dest_unreach | source_quench | redirect | echo | time_exceeded | parameterprob | timestamp | timestampreply | info_request | info_reply | address | addressreply ICMP_code = unreach_net | unreach_host | unreach_protocol | unreach_port | unreach_needfrag | unreach_srcfail | redirect_net | redirect_host | redirect_tosnet | redirect_toshost | timxceed_intrans | timxceed_reass Id = uint16() Sequence = uint16() Payload = binary() Packet = binary() Convenience function for creating arbitrary ICMP packets. This function will calculate the ICMP checksum and insert it into the packet. filter(Socket) -&gt; {ok, Filter} | unsupported filter(Socket, Filter) -&gt; ok | unsupported Types Socket = pid() Filter = binary() Sets or retrieves an ICMPv6 filter on a socket. For ICMPv4 sockets, the atom &#39; unsupported &#39; is returned . Filters can be generated by using the icmp6_filter functions . icmp6_filter_setblockall ( ) -&gt; binary ( ) icmp6_filter_setpassall ( ) -&gt; binary ( ) icmp6_filter_setpass ( Type , Filter ) -&gt; binary ( ) icmp6_filter_setblock ( Type , Filter ) -&gt; binary ( ) icmp6_filter_willpass ( Type , Filter ) -&gt; true | false icmp6_filter_willblock ( Type , Filter ) -&gt; true | false Types Type = icmp_type ( ) Filter = binary ( ) Generate a ICMPv6 filter that can be set on a socket using filter / 2 . For example , to generate a filter that allowed only ICMP6_ECHO_REPLY messages : { ok , Socket } = gen_icmp :open ( [ inet6 ] ) , Filter = gen_icmp :icmp6_filter_setpass ( echo_reply , gen_icmp :icmp6_filter_setblockall ( ) ) , ok = gen_icmp :filter ( Socket , Filter ) . Traceroute tracert is an Erlang traceroute implementation built using gen_icmp. host ( Host ) -&gt; Path host ( Host , Options ) -&gt; Path host ( Socket , Host , Options ) -&gt; Path Types Socket = pid ( ) Host = Address | Hostname Address = tuple ( ) Hostname = string ( ) Options = [ Option ] Option = { protocol , Protocol } | { max_hops , uint ( ) } | { timeout , uint ( ) } | { setuid , bool ( ) } | { saddr , Address } | { sport , uint16 ( ) } Protocol = icmp | udp Path = [ { Address , MicroSeconds , { Protocol , binary ( ) } | timeout ] Perform a traceroute to a destination . ICMP and UDP probes are supported . ICMP probes are the default . max_hops is the maximum TTL ( default : 30 ) Set the time in milliseconds to wait for a response using the timeout option ( default : 1000 ms ) . WARNING : if the response arrives after the timeout , tracert will insert spurious entries into the path . tracert will not spawn the setuid helper if the { setuid , false } option is used . In this case , beam must either be running as root or have the cap_net_raw privileges under Linux . The { sport , Port } option sets the initial source port for UDP probes . The port will be incremented by 1 for each subsequent probe ( default : random high port ) . For ICMP probes , the ICMP ID field will be set to this value . The return value is an ordered list of tuples : Address : the source address responding to the probe MicroSeconds : time elapsed between the probe and receiving the response Protocol : icmp or udp Protocol data : a binary representing the received packet contents path ( Path ) -&gt; Reasons Types Path = [ { Address , MicroSeconds , { Protocol , binary ( ) } ] Reasons = [ { Address , MicroSeconds , Reason } ] Reason = ICMP | UDP | timeout ICMP = timxceed_intrans | echo_reply | ... UDP = unreach_port | ... Convert the list of binaries returned by host / 1 , 2 , 3 to atoms representing the ICMP response codes and UDP errors .","ref":"readme.html#exports"},{"type":"extras","title":"Overview - COMPILING","doc":"rebar3 do clean , compile , ct Also see the README for procket for additional setup (the procket executable needs superuser privileges).","ref":"readme.html#compiling"},{"type":"extras","title":"Overview - EXAMPLE","doc":"Simple ping interface 1 &gt; gen_icmp :ping ( &quot;www.google.com&quot; ) . [ { ok , &quot;www.google.com&quot; , { 173 , 194 , 64 , 99 } , { 173 , 194 , 64 , 99 } , 18411 , 0 , 50 , &lt;&lt; &quot; ! \\&quot; #$%&amp;&#39;()*+,-./0123456789:;&lt;=&gt;?@ABCDEFGHIJKLMNO&quot; &gt;&gt; } ] 2 &gt; gen_icmp :ping ( [ &quot;www.google.com&quot; , { 192 , 168 , 213 , 4 } , &quot;193.180.168.20&quot; , { 192 , 0 , 32 , 10 } ] ) . [ { error , timeout , &quot;193.180.168.20&quot; , { 193 , 180 , 168 , 20 } } , { error , unreach_host , { 192 , 168 , 213 , 4 } , { 192 , 168 , 213 , 4 } , { 192 , 168 , 213 , 54 } , { 18411 , 2 , undefined } , &lt;&lt; 69 , 0 , 0 , 84 , 0 , 0 , 64 , 0 , 64 , 1 , 15 , 29 , 192 , 168 , 213 , 54 , 192 , 168 , 213 , 4 , ... &gt;&gt; } , { ok , { 192 , 0 , 32 , 10 } , { 192 , 0 , 32 , 10 } , { 192 , 0 , 32 , 10 } , { 18411 , 1 , 103 } , &lt;&lt; &quot; ! \\&quot; #$%&amp;&#39;()*+,-./0123456789:;&lt;=&gt;?@ABCDEFGHIJKLMNO&quot; &gt;&gt; } , { ok , &quot;www.google.com&quot; , { 173 , 194 , 77 , 99 } , { 173 , 194 , 77 , 99 } , { 18411 , 0 , 50 } , &lt;&lt; &quot; ! \\&quot; #$%&amp;&#39;()*+,-./0123456789:;&lt;=&gt;?@ABCDEFGHIJKLMNO&quot; &gt;&gt; } ] IPv6 1 &gt; gen_icmp :ping ( &quot;google.com&quot; , [ inet6 ] ) . [ { ok , &quot;google.com&quot; , { 9735 , 63664 , 16395 , 2054 , 0 , 0 , 0 , 4098 } , { 9735 , 63664 , 16395 , 2054 , 0 , 0 , 0 , 4098 } , { 18411 , 0 , 64 , 62 } , &lt;&lt; &quot; ! \\&quot; #$%&amp;&#39;()*+,-./0123456789:;&lt;=&gt;?@ABCDEFGHIJKLMNO&quot; &gt;&gt; } ] 2 &gt; tracert :host ( &quot;google.com&quot; , [ inet6 ] ) . Re-using the ICMP ping socket Keeping the ICMP socket around between runs is more efficient: { ok , Socket } = gen_icmp :open ( ) , P1 = gen_icmp :ping ( Socket , [ { 10 , 1 , 1 , 1 } , &quot;www.google.com&quot; ] , [ ] ) , P2 = gen_icmp :ping ( Socket , [ { 10 , 2 , 2 , 2 } , &quot;www.yahoo.com&quot; ] , [ ] ) , gen_icmp :close ( Socket ) . Working with ICMP sockets { ok , Socket } = gen_icmp :open ( ) . % By default , the ICMP socket is in passive mode ok = gen_icmp :setopts ( Socket , [ { active , true } ] ) , % ICMP host unreachable , empty payload ( should contain an IPv4 header % and the first 8 bytes of the packet data ) Packet = gen_icmp :packet ( [ { type , 3 } , { code , 0 } ] , &lt;&lt; 0 : 160 , 0 : 64 &gt;&gt; ) . gen_icmp :send ( Socket , { 127 , 0 , 0 , 1 } , Packet ) , % Put the socket back into passive mode ok = gen_icmp :setopts ( Socket , [ { active , false } ] ) . Setting Up an ICMP Ping Tunnel ptun is an example of using gen_icmp to tunnel TCP over ICMP. To compile ptun: make eg Host1 (1.1.1.1) listens for TCP on port 8787 and forwards the data over ICMP: erl - noshell - pa ebin deps / * / ebin - eval &#39;ptun:server({2,2,2,2},8787)&#39; - s erlang halt Host2 (2.2.2.2) receives ICMP echo requests and opens a TCP connection to 127.0.0.1:22: erl - noshell - pa ebin deps / * / ebin - eval &#39;ptun:client({1,1,1,1},22)&#39; - s erlang halt To use the proxy on host1: ssh - p 8787 127.0 . 0.1 Traceroute ICMP traceroute 1 &gt; Path = tracert :host ( { 8 , 8 , 8 , 8 } ) . [ { { 216 , 239 , 46 , 191 } , 36149 , { icmp , &lt;&lt; 11 , 0 , 111 , 150 , 0 , 0 , 0 , 0 , 69 , 128 , 0 , 84 , 0 , 0 , 64 , ... &gt;&gt; } } , { { 216 , 239 , 47 , 189 } , 51459 , { icmp , &lt;&lt; 11 , 0 , 111 , 150 , 0 , 0 , 0 , 0 , 69 , 128 , 0 , 84 , 0 , 0 , ... &gt;&gt; } } , { { 8 , 8 , 8 , 8 } , 34946 , { icmp , &lt;&lt; 0 , 0 , 170 , 0 , 219 , 104 , 0 , 0 , 32 , 33 , 34 , 35 , 36 , ... &gt;&gt; } } ] 2 &gt; tracert :path ( Path ) . [ { { 216 , 239 , 46 , 191 } , 62815 , timxceed_intrans } , { { 216 , 239 , 47 , 189 } , 44244 , timxceed_intrans } , { { 8 , 8 , 8 , 8 } , 34825 , echoreply } ] UDP traceroute 1 &gt; Path = tracert :host ( { 8 , 8 , 8 , 8 } , [ { protocol , udp } ] ) . IPv6 traceroute 1 &gt; Path = tracert :host ( &quot;google.com&quot; , [ inet6 ] ) . TODO tests: do not depend on list order handle rfc 4884 (Extended ICMP to Support Multi-Part Messages) handle ICMP router renumbering messages IPv6: handle socket ancillary data (RFC 3542) retrieve the packet TTL rather than using the IPV6_UNICAST_HOPS","ref":"readme.html#example"},{"type":"extras","title":"LICENSE","doc":"Copyright (c) 2010-2023 Michael Santos &lt;michael.santos@gmail.com&gt;. All rights reserved. Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met: 1. Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer. 2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution. 3. Neither the name of the copyright holder nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS &quot;AS IS&quot; AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.","ref":"license.html"}]